<?php
/*
Plugin Name: Upload Plus
Plugin URI: none
Description: This is a enhanced version of the upload feature
Author: Bill Bellon
Version: 0.9
Author URI: http://www.ssec.wisc.edu/~billb/
*/ 
define('UP_URL', $_SERVER['PHP_SELF'] . '?page=uploadplus/uploadplus.php');

//====================================================================================
// FUNCTIONS: BEGIN
//====================================================================================

/* -----------------------------------------------------
------------------------------------------------------- */
function up_fileNameInDB($filename) {
  // remove path and any other non-alphanumeric characters from beginning of filename
  $filename = preg_replace('/^[^a-zA-Z0-9]*/', '', $filename);     

  // strip off any leading "file#####" from filename
  while ( preg_match('/^file[0-9]{5}[^0-9]/', $filename) ) {
    $filename = preg_replace('/^file[0-9]{5}[^0-9]/', '' ,$filename);  
  }

  // if stripped down to just a file extension or a leading ".", make up a filename
  if ( preg_match('/^\./', $filename) ) {
    $filename = date("YmdHi") . $filename;
  }

  return $filename;
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_realFileName($filename, $id) {
  $filename = preg_replace('/^[^a-zA-Z0-9]*/', '', $filename);     

  // add "file###ID." to beginning of filename if not already there
  if ( !(preg_match('/^file[0-9]{5}\.[a-zA-Z0-9]+/', $filename)) ) {
    $filename = 'file' . sprintf("%05d", $id) . '.' . $filename;    
  }

  $filename = '/var/apache/cimss/htdocs/goes_r/awg/wp-content/files/'.$filename;

  return $filename;

}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_renameFile($oldfilename, $newfilename, $id) {
  $oldfilename = up_realFileName($oldfilename, $id); 
  $newfilename = up_realFileName($newfilename, $id); 

  if (rename($oldfilename, $newfilename)) {
    return true;
  } else {
    return false;
  }
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_removeFile($filename, $id) {
  $filename = up_realFileName($filename, $id); 

  if (unlink($filename)) {
    return true;
  } else {
    return false;
  }
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_file_exists($filename, $id) {
  $filename = up_realFileName($filename, $id);

  if (file_exists($filename)) {
    return true;
  } else {
    return false;
  }
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_getFileSize($filename, $id) {

  if (up_file_exists($filename, $id)) {
    $filesize = filesize(up_realFileName($filename, $id));
  } else {
    $filesize = 'file does not exist';
  }
  return $filesize;
}

/* -----------------------------------------------------
Get connection to database
------------------------------------------------------- */
function up_getConnection() {
  if ( !($connection = @mysql_connect('localhost:3306', 'billb', 'billb@ssec')) || !(mysql_select_db('goesr_blog', $connection)) ) {
    up_showerror();
  }
  return $connection;
}

/*-------------------------------------------------
Shows an error and stops the script
------------------------------------------------ */
function up_showerror($message='NULL') {

//    print('<div class="wrap">'."\n");
    print("<ul>\n");
    if ($message != 'NULL') {
      if (is_array($message)) {
        for ($i=0; $i < count($message); $i++) {
          print("<li>$message[$i]</li>\n");
        }
      } else {
        print("<li>$message</li>\n");
      }
    } 

    if (mysql_error()) {
		print("<li>Database error</li>");
// the following generates log messages that are too ugly
//		$trace = print_r(debug_backtrace(), true);
//		error_log('Database error'.mysql_errno().' : '.mysql_error().' '.$trace);
	}
    print("</ul>\n");
    print("</div>\n");

    // footer
    print("</body></html>");
    die();

}

/* -----------------------------------------------------
------------------------------------------------------- */
/*
function up_closeConnection($result, $connection) {

  mysql_free_result($result);
  mysql_close($connection);
}
*/

/* -----------------------------------------------------
Show an authorization failure error message to the user.
------------------------------------------------------- */
function up_authorizationFailure() {
  die('You are not authorized to perform this operation');
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_clean($input, $maxlength) {
	$input = substr($input, 0, $maxlength);
	return EscapeShellCmd($input);
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_checkId($id) {
	if (!is_numeric($id)) {
		die('Invalid id');
	}
}

/* -----------------------------------------------------
------------------------------------------------------- */
/*
function up_makelinks ($content = '') {

  return preg_replace("/foo/", "bar", $content);
}
*/


//====================================================================================
// FUNCTIONS: END
//====================================================================================

?>
