<?php
/*
Plugin Name: Upload Plus
Plugin URI: none
Description: This is a enhanced version of the upload feature
Author: Bill Bellon
Version: 1.0
Author URI: http://www.ssec.wisc.edu/~billb/
*/ 

//====================================================================================
// END OF MAIN PROGRAM UNIT AND BEGINNING OF FUNCTIONS
//====================================================================================

function uploadplus_add_admin_menu_pages() {
  // not sure why I need to specify "__FILE__" for the file parameter, but that is what all of the examples
  // use
  add_management_page('UploadPlus', 'UploadPlus', 8, __FILE__, 'up_manager');
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_manager() {
  global $user_level;

		
  if ($user_level < 6) {
    up_authorizationFailure();
  }

  if (isset($_GET['up_action'])) {
	  $up_action=up_clean($_GET['up_action'], 20);
      if (!isset($_GET['up_id'])) {
        die('No id');
      }
      if (isset($_GET['up_filename'])) {
        $up_filename = up_clean($_GET['up_filename'], 255);
      }
      $up_id=up_clean($_GET['up_id'], 6);
	
      switch ($up_action) {
      case "checkout":
        up_checkId($up_id);
        up_checkOut($up_id, $up_filename);
        break;
      default:
        die("Invalid action");
        break;
      }
  } else {
    up_showForm();
  }

}

/* -----------------------------------------------------
Show the Upload Plus form
------------------------------------------------------- */
function up_showForm() {
  $connection = up_getConnection();
?>
  <div class="wrap">
  <h2>Upload Plus</h2>
<?php
  $sql = 'SELECT COUNT(id) FROM wp_uploadplus';
  if (!($result = @mysql_query($sql, $connection))) {
    showerror();
  }
  if (mysql_result($result, 0, 0) < 1):
    print('No files yet.');
  else:
?>
    <table>
    <thead>
      <tr><th>ID</th><th>Title</th><th>File Name</th><th>Description</th><th>Size (bytes)</th><th>Created</th><th>Modified</th><th><!--View/Download--></th><th><!--Checkout and Edit / Checkin--></th><th><!--Edit Properties--></th><th><!--Delete--></th></tr>
    </thead>
    <tbody>
<?php
    $sql = 'SELECT id, title, filename, description, created, modified, checkedout FROM wp_uploadplus ORDER BY id DESC';
	
    if (!($result = @mysql_query($sql, $connection))) {
      showerror();
    }
	
    $rowCount = 0;
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
      $isEven = ($rowCount % 2) == 0;
      $rowClass = $isEven ? " class=\"alternate\"" : "";

      print('<tr'.$rowClass.'>');
      print('<td>'.$row['id'].'</td>');
      print("<td>".$row["title"]."</td>");
      print("<td>".$row["filename"]."</td>");
      print("<td>".$row["description"]."</td>");
      print('<td>' . up_getFileSize($row['filename']) . '</td>');
      print("<td>".$row["created"]."</td>");
      print("<td>".$row["modified"]."</td>");

/*----------------------------------------------------
NOT WORKING      print('<td><a href="' . up_makeURL(__FILE__ ). '?up_action=view&amp;id='.$row['id'].'&amp;filename=' . $row['filename'] . '">View</a></td>');
      print('<td><a href="/wp-test/wp-content/plugins/uploadplus/uploadplus.php?up_action=view&amp;up_id='.$row['id'].'&amp;filename=' . $row['filename'] . '">View</a></td>');
----------------------------------------------------*/
      print('<td><a href="/wp-test/wp-content/files/'.$row['filename'].'">View</a></td>');
      if ($row["checkedout"]) {
        print('<td><a href="#">Checkin</a></td>');
      } else {
        print('<td><a href="/wp-test/wp-admin/edit.php?page=uploadplus/uploadplus.php&amp;up_action=checkout&amp;up_id='.$row['id'].
              '&amp;up_filename='.$row['filename'].'">Checkout &amp; edit</a></td>');
      }
      print('<td><a href="#">Edit Properties</a></td>');
      print('<td><a href="#">Delete</a></td>');
      print("</tr>\n");

      $rowCount++;
    }

    mysql_free_result($result);
?>
    </tbody>
    </table>
<?php
  endif;
?>
  </div>
<?php
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_checkOut($id, $filename) {
?>
  <div class="wrap">
  <h2>Upload Plus</h2>
<?php
   // UPDATE DATABASE WITH CHECKOUT STATUS
   echo "FILE HAS BEEN CHECKED OUT<br>\n";
?>  
  <a href="/wp-test/wp-content/files/<?php print($filename); ?>">Download file</a>
  </div>
<?php
}

/* -----------------------------------------------------
------------------------------------------------------- */
/*==================================
DECIDED TO NOT USE THIS LOGIC FOR NOW
//function up_viewFile($id) {
function up_viewFile($filename) { // MAYBE SHOULD USE $ID INSTEAD OF $FILENAME
// MAYBE INSTEAD OF PRINTING A SEPARATE PAGE WITH A DOWNLOAD LINK FOR THE FILE, JUST
//   MAKE THE VIEW LINK IN THE SHOWFORM() FUNCTION A LINK TO THE FILE - WHY GO THROUGH
//   AN EXTRA PAGE/FUNCTION (ONLY REASON I CAN SEE IS IF I DECIDE LATER TO SAVE FILES
//   ON SERVER AS "file_id" OR SOMETHING LIKE THAT AND THEN USE A FUNCTION THAT WILL
//   GRAB THAT FUNCTION AND SEND IT TO THE USER WITH THE FILENAME SPECIFIED IN THE DATABASE

  <div class="wrap">
  <h2>Upload Plus</h2>
  <a href="
  </div>
}
=====================================*/

/* -----------------------------------------------------
------------------------------------------------------- */
function up_makeURL($filename) {
  return preg_replace('/^\/var\/apache\/test\/htdocs\//', '', $filename);
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_getFileSize($filename) {
  return -9999;
}

/* -----------------------------------------------------
Get connection to database
------------------------------------------------------- */
function up_getConnection() {
  if ( !($connection = @mysql_connect('localhost:3306', 'billb', 'billb@ssec')) || !(mysql_select_db('test', $connection)) ) {
    showerror();
  }
/*
  if (!($connection = @mysql_pconnect(DB_HOST, DB_USER, DB_PASSWORD)) || !mysql_select_db(get_option('db_file_database'), $connection)) {
    showerror();
  }
*/
  return $connection;
}

/*-------------------------------------------------
Shows an error and stops the script
------------------------------------------------ */
function showerror() {
	if (mysql_error()) {
		$trace = print_r(debug_backtrace(), true);
//		die('Database error');
//		error_log('Database error'.mysql_errno().' : '.mysql_error().' '.$trace);
		die('Database error'.mysql_errno().' : '.mysql_error().' '.$trace);
	} else {
		die('Could not connect to the database');
	}
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_closeConnection($result, $connection) {
  mysql_free_result($result);
  mysql_close($connection);
}

/* -----------------------------------------------------
Show an authorization failure error message to the user.
------------------------------------------------------- */
function up_authorizationFailure() {
  die('You are not authorized to perform this operation');
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_clean($input, $maxlength) {
	$input = substr($input, 0, $maxlength);
	return EscapeShellCmd($input);
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_checkId($id) {
	if (!is_numeric($id)) {
		die('Invalid id');
	}
}

//=============================================================
//=============================================================

add_action('admin_menu', 'uploadplus_add_admin_menu_pages');

?>
