<?php
/*
Plugin Name: Upload Plus
Plugin URI: none
Description: This is a enhanced version of the upload feature
Author: Bill Bellon
Version: 0.4
Author URI: http://www.ssec.wisc.edu/~billb/
*/ 
include_once('functions.inc');

//====================================================================================
// FUNCTIONS: BEGIN
//====================================================================================

function uploadplus_add_admin_menu_pages() {
  // not sure why I need to specify "__FILE__" for the file parameter, but that is what all of the examples
  // use
  add_management_page('UploadPlus', 'UploadPlus', 8, __FILE__, 'up_manager');
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_manager() {
  global $user_level;

  if ($user_level < 6) {
    up_authorizationFailure();
  }

  if (isset($_GET['up_action'])) {
	  $up_action=up_clean($_GET['up_action'], 20);
      if (!isset($_GET['up_id'])) {
        die('No id');
      }
      if (isset($_GET['up_filename'])) {
        $up_filename = up_clean($_GET['up_filename'], 255);
      }
      $up_id=up_clean($_GET['up_id'], 6);
      up_checkId($up_id);
	
      switch ($up_action) {
      case "delete":
        up_deleteFile($up_id);
        break;
      case "edit":
        up_editProperties($up_id);
        break;
      case "checkout":
        up_checkOut($up_id, $up_filename);
        break;
      default:
        die("Invalid action");
        break;
      }
  } else {
    up_showForm();
  }

}

/* -----------------------------------------------------
Show the Upload Plus form
------------------------------------------------------- */
function up_showForm() {
  $connection = up_getConnection();
?>
  <div class="wrap">
  <h2>Upload Plus: File List</h2>
<?php
  // GET RID OF THIS 1st SQL CONNECTION AND MODIFY SQL CONNECTION BELOW TO INCLUDE 
  // LOGIC FOR DECIDING WHETHER OR NOT THERE ARE ANY RESULTS
  $sql = 'SELECT COUNT(id) FROM wp_uploadplus';
  if (!($result = @mysql_query($sql, $connection))) {
    up_showerror();
  }
  if (mysql_result($result, 0, 0) < 1):
    print('No files yet.');
  else:
?>
    <table>
    <thead>
      <tr><th>ID</th><th>Title</th><th>File Name</th><th>Description</th><th>Size (bytes)</th><th>Created</th><th>Modified</th>
          <th><!--View/Download--></th><th><!--Checkout and Edit / Checkin--></th><th><!--Edit Properties--></th>
          <th><!--Delete--></th></tr>
    </thead>
    <tbody>
<?php
    $sql = 'SELECT id, title, filename, description, created, modified, checkedout FROM wp_uploadplus ORDER BY id DESC';
	
    if (!($result = @mysql_query($sql, $connection))) {
      up_showerror();
    }
	
    $rowCount = 0;
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
      $isEven = ($rowCount % 2) == 0;
      $rowClass = $isEven ? " class=\"alternate\"" : "";

      print('<tr'.$rowClass.'>');
      print('<td>'.$row['id'].'</td>');
      print("<td>".$row["title"]."</td>");
      print("<td>".$row["filename"]."</td>");
      print("<td>".$row["description"]."</td>");
      print('<td>' . up_getFileSize($row['filename']) . '</td>');
      print("<td>".$row["created"]."</td>");
      print("<td>".$row["modified"]."</td>");
      print('<td><a href="/wp-test/wp-content/files/'.$row['filename'].'">View</a></td>');
      if ($row["checkedout"] != '') { // checked out
        print('<td><a href="#" title="checked out by: '.$row['checkedout'].'">Checkin</a></td>');
      } else { // checked in
        print('<td><a href="' . UP_URL . '&amp;up_action=checkout&amp;up_id='.$row['id'].
              '&amp;up_filename='.$row['filename'].'">Checkout &amp; edit</a></td>');
      }
      print('<td><a href="'.UP_URL.'&amp;up_action=edit&amp;up_id='.$row['id'].'">Edit Properties</a></td>');
      print('<td><a href="'.UP_URL.'&amp;up_action=delete&amp;up_id='.$row['id'].'">Delete</a></td>');
//      print('<td><a href="#">Delete</a></td>');
      print("</tr>\n");

      $rowCount++;
    }

    mysql_free_result($result);
    mysql_close($connection);
?>
    </tbody>
    </table>
<?php
  endif;
?>
  </div>
<?php
}
/* -----------------------------------------------------
------------------------------------------------------- */
function up_deleteFile($id) {
  echo '<div class="wrap">'."\n";
  echo "<h2>Upload Plus: Edit Properties</h2>\n";
  $connection = up_getConnection();

  $sql = 'SELECT filename FROM wp_uploadplus WHERE id='.$id.' AND checkedout IS NULL';
  if (!($result = @mysql_query($sql, $connection))) {
    up_showerror();
  }
  if (mysql_num_rows($result) == 1) {
    $filename=mysql_result($result, 0, 0);
    $filename = preg_replace('/^[^a-zA-Z0-9]*/', '', $filename);     
    $filename = '/var/apache/test/htdocs/wp-test/wp-content/files/'.$filename;

    if (file_exists($filename)) {
      // DELETE FROM DATABASE
      $sql = 'DELETE FROM wp_uploadplus WHERE id='.$id;
      @mysql_query($sql, $connection); 
      if (@mysql_affected_rows() != 1) {
        //TO DO: rename the file back to old filename
        die("ERROR: could not delete record from database\n");
      }

      // DELETE ACTUAL FILE
      if (!unlink($filename)) {
        die("could not delete file");
      } 
    } else {
      die("requested file does not exist");
    }
  } else {
    die("requested file to delete does not exist in database or is checked out");
  }
  
  echo '<p>The file: '.$filename.' (id='.$id.') has been deleted and removed from the database</p>'."\n";

  mysql_free_result($result); 
  mysql_close($connection);
  echo "</div>\n";
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_editProperties($id) {

  echo '<div class="wrap">'. "\n";
  echo "<h2>Upload Plus: Edit Properties</h2>\n";
  $connection = up_getConnection();

  if (isset($POST['up_id']) && $id != $_POST['up_id']) {
    die("id's do not match\n");
  }

  // IF DATA HAS BEEN SUBMITTED, WRITE TO DATABASE FIRST
  if ($_POST['up_editSubmitted']) {
    $_POST['up_title'] = up_clean($_POST['up_title'], 255);
//    $_POST['up_title'] = addslashes($_POST['up_title']);  NOT SURE IF I NEED THIS

    $_POST['up_filename'] = up_clean($_POST['up_filename'], 255);
    $_POST['up_filename'] = addslashes($_POST['up_filename']);
    $_POST['up_filename'] = preg_replace('/^[^a-zA-Z0-9]*/', '', $_POST['up_filename']);

    $_POST['up_description'] = up_clean($_POST['up_description'], 255);
//    $_POST['up_description'] = addslashes($_POST['up_description']);  NOT SURE I NEED THIS

    $sql = "UPDATE wp_uploadplus SET title='".$_POST['up_title']."', filename='".$_POST['up_filename']."', description='".
           $_POST['up_description']."' WHERE id=".$id;

    // TRY TO RENAME/MOVE FILE IF FILENAME HAS CHANGED
    if ($_POST['up_oldfilename'] != $_POST['up_filename']) {
      up_renameFile($_POST['up_oldfilename'], $_POST['up_filename']);
    }

    @mysql_query($sql, $connection); 
    if (@mysql_affected_rows() != 1) {
      //rename the file back to old filename
      die("ERROR: properties not updated\n");
    }
  }

  // READ DATA FROM DATABASE AND DISPLAY IN FORM
  $sql = 'SELECT title, filename, description, created, modified, checkedout FROM wp_uploadplus WHERE id='.$id;
  if (!($result = @mysql_query($sql, $connection))) {
    up_showerror();
  }

  $num_rows = @mysql_num_rows($result);
  if ($num_rows == 1) {
    $row = mysql_fetch_array($result, MYSQL_ASSOC);
//    print('<form action="'.UP_URL.'" method="post">'."\n");
    print('<form action="'.UP_URL.'&amp;up_action=edit&amp;up_id='.$id.'" method="post">'."\n");
    print ('<table><thead>
      <tr><th>ID</th><th>Title</th><th>File Name</th><th>Description</th><th>Size (bytes)</th><th>Created</th><th>Modified</th>
          <th><!--Checkout and Edit / Checkin--></th></tr></thead><tbody>');
    print("<tr>\n");
    print('<td>'.$id.'<input type="hidden" name="up_id" id="up_id" value="'.$row['id'].'"></td>'."\n");
    print('<td><input type="text" name="up_title" id="up_title" value="'.$row['title'].'" maxlength="255" size="25"></td>'."\n");
    print('<td><input type="text" name="up_filename" id="up_filename" value="'.$row['filename'].'" maxlength="255" size="25"></td>'."\n");
    print('<td><input type="text" name="up_description" id="up_description" value="'.$row['description'].'" maxlength="255" size="25"></td>'."\n");
    print('<td>' . up_getFileSize($row['filename']) . '</td>'."\n");
    print("<td>".$row["created"]."</td>\n");
    print("<td>".$row["modified"]."</td>\n");
    if ($row["checkedout"] != '') { // checked out
      print('<td>Checked out by '.$row['checkedout']."</td>\n");
    } else {  // checked in
      print("<td>&nbsp;</td>\n");
    }
    print("</tr></tbody></table>\n");
    print('<div style="text-align: center; margin-top: 10px;"><input type="submit" name="up_submit_edit" value="Submit changes"></div>'."\n");
    print('<input type="hidden" name="up_editSubmitted" id="up_editSubmitted" value="true">'."\n");
    print('<input type="hidden" name="up_oldfilename" id="up_oldfilename" value="'.$row['filename'].'">'."\n");
    print("</form>\n");
  } else if ($num_rows < 1) {
     up_showerror('ERROR: Too many rows retrieved for requested ID');
  } else {
     up_showerror('ERROR: no data returned for requested ID');
  }
	
  mysql_free_result($result); 
  mysql_close($connection);

  echo "</div>\n";

}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_checkOut($id, $filename) {
  global $userdata;
  get_currentuserinfo();

  echo '<div class="wrap">'. "\n";
  $connection = up_getConnection();

//   echo '<div style="font-size: 90%; margin-bottom: 10px;"><a href="'.UP_URL.'">Back to file list</a></div>'."\n";
  // TRY TO CHECK OUT FILE AND DISPLAY RESULTS
  $sql = "UPDATE wp_uploadplus SET checkedout='".$userdata->user_login."' WHERE id=" . $id . ' AND checkedout IS NULL';
  if ( @mysql_query($sql, $connection) ):
    if (@mysql_affected_rows() == 1) {
      echo "<h2>Upload Plus: File check out</h2>\n";
      echo '<p>This file has been checked out.  Download file, make your changes, then check the file back in
               by clicking on the link entitled &quot;checkin&quot; on the File List page</p>'."\n";
      echo '<p><a href="/wp-test/wp-content/files/' . $filename . '">Download file</a></p>' . "\n";
    } else {
      echo '<h2>Upload Plus: File is <span style="color: red;">already checked out</span>!</h2>'."\n";
      echo '<p>This file is already checked out by: &nbsp;&nbsp;<span style="color: red; font-size: 115%;">'.$userdata->user_login."</span>.&nbsp;&nbsp;  Wait until this person has checked
               the file back in or contact the administrator if you encounter any problems.</p>\n";
    }
  else:
    up_showerror();
  endif;

//  mysql_free_result($result); GIVES ME AN ERROR MESSAGE ABOUT $result not being a valid resource
  mysql_close($connection);

  echo "</div>\n";
}

/* -----------------------------------------------------
------------------------------------------------------- */
function up_makefilelist($content = '') {
  $tagRegExp = '/<\!\-\-[ ]*UPLOADPLUS[ ]+ACTION="([a-zA-Z0-9 ]+)"[ ]+NUM="([a-zA-Z0-9 ]+)"[ ]*-->/i';
  if( preg_match($tagRegExp, $content, $matches) ) {
    $action=$matches[1];
    $num=$matches[2];

    if (strtolower($action) == 'filelist' && ($num >= 1 || strtolower($num) == 'all')) {
      $connection = up_getConnection();

      $sql = 'SELECT id, title, description FROM wp_uploadplus ORDER BY id DESC';

      if ($num == 'all') $num = 9999; // a really, really bad way to program, but i'm lazy
	
      if ($result = @mysql_query($sql, $connection)) {
        $rowCount = 1;
        $filelist = "<ul>\n";
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
          $filelist = $filelist . '<li><a href="/wp-test/wp-content/files/file.php?up_id='.$row['id'].'" title="'.$row['description'].'">'.$row['title']."</a></li>\n";
          $rowCount++;
          if ($rowCount > $num) break;
        }

        $content=preg_replace($tagRegExp, $filelist, $content);    

      }
      @mysql_free_result($result);
      @mysql_close($connection);
    }
  }

  return $content;
}

//====================================================================================
// END OF FUNCTIONS
//====================================================================================

add_filter('the_content', 'up_makefilelist');
add_action('admin_menu', 'uploadplus_add_admin_menu_pages');

?>